	.code16
	.text
	.globl	_start16
_start16:

	call	puts
	.ascii	"LFN test program\r\n\r\n\0"

	call	puts
	.ascii	"710D Reset Drive\r\n\0"
	mov	$0x710d, %ax
	mov	$0, %cx
	mov	$2, %dx
	stc
	call	showregs
	int	$0x21
	call	showregs

	call	puts
	.ascii	"7047 Get Current Directory\r\n\0"
	mov	$0x7147, %ax
	mov	$0, %dl
	mov	$buf, %si
	stc
	call	showregs
	int	$0x21
	call	showregs
	push	$buf
	push	$P7147
	call	printf

	mov	$0x4c00, %ax
	int	$0x21

buf:
	.space	1000
P7147:
	.ascii	"cwd = \"%s\"\r\n\0"

#----------------------------------------------------------------------

showregs:
	pushf
	pusha
	pushf
	push	%bp
	push	%di
	push	%si
	push	%dx
	push	%cx
	push	%bx
	push	%ax
	push	$msg1
	call	printf
	popa
	popf
	ret

msg1:	.ascii	"AX=%x BX=%x CX=%x DX=%x SI=%x DI=%x BP=%x %f\r\n\0"

#----------------------------------------------------------------------

printf_ret:
	.word	0

printf:
	pop	%ax
	mov	%ax, printf_ret

	pop	%si
printf_toploop:
	mov	(%si),%dl
	inc	%si
	cmp	$0, %dl
	jne	1f
	jmp	*printf_ret
1:
	cmp	$'%', %dl
	je	printf_percent
1:
	mov	$2, %ah
	push	%si
	int	$0x21
	pop	%si
	jmp	printf_toploop

printf_percent:
	mov	(%si),%dl
	inc	%si
	cmp	$'x', %dl
	je	printf_x
	cmp	$'s', %dl
	je	printf_s
	cmp	$'f', %dl
	je	printf_f
	jmp	1b

printf_x:
	pop	%dx
	push	%si
	call	hexout
	pop	%si
	jmp	printf_toploop

printf_s:
	pop	%di
	push	%si
1:
	mov	(%di), %dl
	inc	%di
	cmp	$0, %dl
	je	2f
	mov	$2, %ah
	int	$0x21
	jmp	1b
2:
	pop	%si
	jmp	printf_toploop

printf_f:
	pop	%bx
	push	%si
	mov	$flag_chars+8, %si
	mov	$8, %cx
printf_f_1:
	mov	$'-', %dl
	test	$0x0080, %bx
	jz	printf_f_2
	mov	(%si), %dl
printf_f_2:
	inc	%si
	shl	$1, %bx
	mov	$2, %ah
	pusha
	int	$0x21
	popa
	dec	%cx
	jnz	printf_f_1
	pop	%si
	jmp	printf_toploop

flag_chars:	.ascii	"-NPLODITSZ-A-P-C"

#----------------------------------------------------------------------

puts:
	pop	%si
puts1:
	mov	(%si), %dl
	inc	%si
	or	%dl, %dl
	jz	puts2
	mov	$2, %ah
	int	$0x21
	jmp	puts1
puts2:
	jmp	*%si

#----------------------------------------------------------------------

hexout:
	push	%dx
	mov	%dh, %dl
	call	hexout2
	pop	%dx
hexout2:
	push	%dx
	shr	$4, %dl
	call	hexout3
	pop	%dx
hexout3:
	and	$0x0f, %dl
	add	$'0', %dl
	cmp	$'9', %dl
	jbe	hexout4
	add	$7, %dl
hexout4:
	mov	$2, %ah
	int	$0x21
	ret

#----------------------------------------------------------------------
