	.code16
	.text
	.globl	_start16
_start16:

	jmp	start

	# This table must match the tsr_s in lfnnet.c
	.org	4
	.short	helper
chain:
	.short	0,0


helper:
	pop	%ax
	pushf
	cs
	lcall	*chain
	push	%ax
	mov	$0x0260, %ax
	jmp	helper2

isr:
	push	%ax
	mov	$0x0160, %ax
helper2:
	int	$0xe6
	pop	%ax
	cs
	ljmp	*chain

start:
	# get current disk
	mov	$0x19, %ah
	int	$0x21
	# set current disk to current disk
	mov	%al, %dl
	mov	$0x0e, %ah
	int	$0x21
	mov	%al, %dl
	# %dl has last drive number
	mov	$0x0060, %ax
	int	$0xe6

	push	%dx
	add	$'@', %dl
	mov	%dl, msg_drive
	mov	$msg, %dx
	mov	$9, %ah
	int	$0x21

	mov	%cs, %ax
	mov	%ax, %ds
	mov	$0x3521, %ax
	int	$0x21
	mov	%bx, chain
	mov	%es, chain+2
	mov	$isr, %dx
	mov	$0x2521, %ax
	int	$0x21

	pop	%dx
	dec	%dl
	mov	$0x0e, %ah
	int	$0x21

	mov	$start, %dx
	int	$0x27

msg:
	.ascii	"lfntsr installed, drive "
msg_drive:
	.byte '@', ':', 13, 10, '$'
	.align	4,0
